#include <AccelStepperWithDistance.h>    // inculde stepper library 
#include <AccelStepper.h>   // inculde stepper library 
#define HALFSTEP 8      // inculde stepper library ( moved with half steps)
                       // define pins of driver ULN2003
#define motorPin10 10    // Pin 10  in pin IN1 of driver 
#define motorPin11 11     // Pin 11 in  pin IN2 of driver
#define motorPin12 12     // Pin 12 in  pin IN3 of driver 
#define motorPin13 13     // Pin 13 in  pin IN4 of driver 
AccelStepper stepper(HALFSTEP, motorPin10, motorPin12, motorPin11, motorPin13);  //Initialize stepper /  we name the motor  and we define characteristics ( kind of movment, coil1, coil2,coil3,coil4) 
#include <HCSR04.h>    // include library of ultrasonic sensor
UltraSonicDistanceSensor distanceSensor1(2, 3);  // Initialize sensor that uses digital pins 2 and 3.
UltraSonicDistanceSensor distanceSensor2(4, 5); // Initialize sensor that uses digital pins 4 and 5.
UltraSonicDistanceSensor distanceSensor3(6, 7); // Initialize sensor that uses digital pins 6 and 7.
UltraSonicDistanceSensor distanceSensor4(8, 9); // Initialize sensor that uses digital pins 8 and 9.
int tiempo;                                     //  define "tiempo" as a whole number
const int LEDPin = A2;   //  define "LEDPin" as a whole number
const int LDRPin = A0;  //  define "LDRPin" as a whole number
const int resistencia = 50;//  define "resistencia" as a whole number  / this is the resistance that LDR take as reference
unsigned long t;
#include <Servo.h>            // include library of servomotor
Servo myservo;  // create servo object to control a servo

void setup()                 //initialitzation  / what we say here it happens when the code start, for the whole program
{
  stepper.setMaxSpeed(800.0); // max speed of stepper 
  stepper.setAcceleration(500.0); // max acceleration of stepper
  Serial.begin(9600);  // We initialize serial connection so that we could print values from sensor.
  pinMode(LEDPin, OUTPUT); // initzialize pin A2 as an output pin for  the led
  pinMode(LDRPin, INPUT); // initzialize pin A0 as an input pin for read the LDR
  myservo.attach(A4);  // attaches the servo on pin 9 to the servo object
}

void loop()                 // this is going to happens repeatly all time
{
  int dist1 = distanceSensor1.measureDistanceCm();    //  initzialize dist1 as a whole number that distance sensor 1 define every time
  int dist2 = distanceSensor2.measureDistanceCm();    //  initzialize dist2 as a whole number that distance sensor 2 define every time
  int dist3 = distanceSensor3.measureDistanceCm();    //  initzialize dist3 as a whole number that distance sensor 3 define every time
  int dist4 = distanceSensor4.measureDistanceCm();    //  initzialize dist4 as a whole number that distance sensor 4 define every time
  int input = analogRead(LDRPin);  // input  is the resistance read ( as a whole number)  of ldr ( this is the light read)
                                       // the next lines define how to do the leg movement whe light is low
  if (input < resistencia )  {           // when light is low do the next things ( or when resistane is bigger than input do...)                                    
    digitalWrite(LEDPin, HIGH);          // turn the led on
    myservo.write (15);                  // move servo motor to 15 degrees
    delay (1200);                        // wait 1.2 seconds
    myservo.write (35);                  //  move servo motor to 35 degrees
    delay (150);                         // wait 0.15 seconds
    while (dist1 < 40 && dist1 > 0 || dist2 < 40 && dist2 > 0 || dist3 < 40 && dist3 > 0 || dist4 < 40 && dist4 > 0) {    // if a  distance sensor detects somthing near we entry on next loop ( leg moves faster)
      digitalWrite(LEDPin, HIGH);       // turn the led on
      myservo.write (22);                // move servo motor to 22 degrees
      delay (180);                        // wait 0.18 seconds
      myservo.write (35);               // move servo motor to 35 degrees
      delay (150);                       // wait 0.15 seconds
      int distA = distanceSensor1.measureDistanceCm();         // we initzialize another time the distancesensors because in the loop we can`t take new measures
      int distB = distanceSensor2.measureDistanceCm();
      int distC = distanceSensor3.measureDistanceCm();
      int distD = distanceSensor4.measureDistanceCm();
      if ((distA > 40 || distA < 0  ) && (distB > 40 || distB < 0 ) &&  ( distC > 40 || distC < 0 ) && (distD > 40 || distD < 0  ) || analogRead(LDRPin) > resistencia ) // if distancesensors don`t measure something near or the light is high, keep out of the loop
        break ;
    }
  }
  digitalWrite(LEDPin, LOW);          // turn de led off
  myservo.write (15);                 // move servo to 15 degrees ( original state)

  if (dist1 < 40 && dist1 > 0 ) {     // if distance sensor1 detect something near...
    stepper.runToNewPosition(2038); //    ...move stepper to the position 2038 
    t = millis();                    // save the time program take to be here
  }
  if (dist2 < 40 && dist2 > 0 ) {     // if distance sensor2 detect something near...
    stepper.runToNewPosition(1019); //    ...move stepper to the position 1019
    t = millis();                    // save the time program take to be here
  }
  if  (dist3 < 40 && dist3 > 0 ) {    // if distance sensor3 detect something near...
    stepper.runToNewPosition(0); //    ...move stepper to the position 0
    t = millis();                    // save the time program take to be here
  }
  if (dist4 < 40 && dist4 > 0 ) {         // if distance sensor4 detect something near...
    stepper.runToNewPosition(3280); //    ...move stepper to the position 3080 
    t = millis();                    // save the time program take to be here
  }
  if (millis() - t > 10000)          // if no new reads of distance sensor... ( time now - last time distance sensor is bigger thsn 10 seconds...)
  {
    stepper.runToNewPosition(0);      // ... return to position 0
  }
}
